;    guilayout_demo3.pb
;    Version 0.2 [2011/09/25]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

EnableExplicit

CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awguilayout.pbi"

ProcedureC OnAfterGdg0Resize(GadgetID.i, Left.i, Top.i, Width.i, Height.i)
  Debug "Left Gadget resized"+Chr(10)+"New Size: "+Str(Width)+"x"+Str(Height)
EndProcedure
ProcedureC OnAfterGdg1Resize(GadgetID.i, Left.i, Top.i, Width.i, Height.i)
  Debug "Right Gadget resized"+Chr(10)+"New Size: "+Str(Width)+"x"+Str(Height)
EndProcedure

Define win, gdg0, gdg1
Define *sizer.AWPB_GUILO_Sizer, s1.i

win = OpenWindow(#PB_Any, 542, 122, 410, 410, "GUI-Layout-Demo 3", #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_TitleBar)
If IsWindow(win)
	*sizer = AWPB_CreateSizerObj(win)
	If *sizer
		gdg0 = ButtonGadget(#PB_Any, 0, 0, 100, 10, "first Gadget - without borders, 100% height, 50% width", #PB_Button_MultiLine)
		gdg1 = ButtonGadget(#PB_Any, 0, 0, 100, 10, "second Gadget - with borders a 10 px, 100% height, 50% width", #PB_Button_MultiLine)

		s1   = *sizer\AddSizer(#Null, #AWPB_GUILO_SIZER_HBOX, #AWPB_GUILO_SIZER_REL, 100)
			     *sizer\AddGadget(s1, gdg0, #AWPB_GUILO_SIZER_REL, 50, 0, 0, 0, 0, #Null, @OnAfterGdg0Resize())
			     *sizer\AddGadget(s1, gdg1, #AWPB_GUILO_SIZER_REL, 50, 10, 10, 10, 10, #Null, @OnAfterGdg1Resize())
		
		*sizer\Finish()
		
		Repeat
			Select WaitWindowEvent()
				Case #PB_Event_SizeWindow
					*sizer\Resize(#False, #True)
				Case #PB_Event_CloseWindow
					Select EventWindow()
						Case win
							CloseWindow(win)
							win = 0
							Break
					EndSelect
			EndSelect
		ForEver
		
		*sizer\Destroy()
	Else
		MessageRequester("Fehler", "Konnte Sizer nicht erstellen")  
	EndIf
Else
	MessageRequester("Fehler", "Konnte Fenster nicht erstellen")  
EndIf

End

