;    awcharset.pbi
;    Version 0.1 [2010/10/08]
;    Copyright (C) 2011 Ronny Krger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

XIncludeFile "awsupport.pbi"

;{ Constants
#AWPB_CS_CS_UNKNOWN      = 0             ;* unbekanntes Charset, nur zur Ergebnisauswertung
#AWPB_CS_CS_ISO_8859_15  = 1             ;* Charset ISO-8859-15
;}
;{ private functions
Procedure.i ____CS_GetCharsetCode(charset.s) ;- incomplete
  Protected c.s, t.i
  
  c = UCase(charset)
  If c = "ISO-8859-15"
    t = #AWPB_CS_CS_ISO_8859_15
    
  Else
    t = #AWPB_CS_CS_UNKNOWN
  EndIf
  
  ProcedureReturn t
EndProcedure
Procedure.s ____CS_GetCharsetName(charset.i) ;- incomplete
  Protected c.s
  
  Select charset
    Case #AWPB_CS_CS_ISO_8859_15
      c = "iso-8859-15"
    Default
      c = "unknown"
  EndSelect
  
  ProcedureReturn c
EndProcedure
Procedure.s ____CS_GetHTMLCharset(html.s)
  Protected p.i, e.i, res.s
  
  res = ""
  p   = FindString(html, "charset", p)
  If p
    p = FindString(html, "=", p)
    If p
      e = FindString(html, ">", p + 2)
      If e
        res = ____SUP_TrimWSQ(Mid(html, p + 1, e - p - 1))
        e   = FindString(res, Chr(34), 1)
        If e
          res = ____SUP_TrimWSQ(Left(res, e - 1))
        EndIf
      EndIf
    EndIf
  EndIf
  ProcedureReturn res
EndProcedure  
Procedure.s ____CS_GetSysCharset()           ;- TODO
  ProcedureReturn "iso-8859-1"
EndProcedure
;}
;{ public functions
Procedure.i AWPB_CS_GetCharsetCode(CharsetName.s)
  ProcedureReturn ____CS_GetCharsetCode(CharsetName) 
EndProcedure
Procedure.s AWPB_CS_GetCharsetName(CharsetCode.i)
  ProcedureReturn ____CS_GetCharsetName(CharsetCode)
EndProcedure
Procedure.s AWPB_CS_GetHTMLCharsetName(HTMLCode.s)
  ProcedureReturn ____CS_GetHTMLCharset(HTMLCode)
EndProcedure
Procedure.i AWPB_CS_GetHTMLCharsetCode(HTMLCode.s)
  ProcedureReturn ____CS_GetCharsetCode(____CS_GetHTMLCharset(HTMLCode))
EndProcedure
Procedure.s AWPB_CS_GetSysCharsetName()
  ProcedureReturn ____CS_GetSysCharset()
EndProcedure
Procedure.i AWPB_CS_GetSysCharsetCode()
  ProcedureReturn ____CS_GetCharsetCode(____CS_GetSysCharset())
EndProcedure
;}


