;    awguilayout.pbi
;    Version 0.4 [2012/04/11]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.


#AWPB_GUILO_SIZER_VBOX      = 1
#AWPB_GUILO_SIZER_HBOX      = 2
#AWPB_GUILO_SIZER_FIX       = 3
#AWPB_GUILO_SIZER_REL       = 4
#AWPB_GUILO_SIZER_GDG       = 5
#AWPB_GUILO_SIZER_WINDOW    = 6
#AWPB_GUILO_SIZER_CONTAINER = 7

PrototypeC AWPB_GUILO_OnBeforeResize_Proto(GadgetID.i)
PrototypeC AWPB_GUILO_OnAfterResize_Proto(GadgetID.i, Left.i, Top.i, Width.i, Height.i)

Interface AWPB_GUILO_Sizer
	Destroy      ()
	Finish	     (ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
	Resize       (ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
	AddGadget.b  (ParentSizer.i, GadgetID.i, Mode.b, Size.i, BorderLeft.i = 0, BorderTop.i = 0, BorderRight.i = 0, BorderBottom.i = 0, *OnBeforeResizeCallback.AWPB_GUILO_OnBeforeResize_Proto = #Null, *OnAfterResizeCallback.AWPB_GUILO_OnAfterResize_Proto = #Null)
	AddSizer.i   (ParentSizer.i, Type.b, Mode.b, Size.i)
	MinWidth.i   (ParentSizer.i = #Null)
	MinHeight.i  (ParentSizer.i = #Null)
EndInterface
Structure ____AWPB_GUILO_Sizer_Data
	; calculated values
	l.i
	t.i
	r.i
	b.i
	w.i
	h.i
	
	; given values
	type.b
	mode.b
	size.i
	bleft.i
	btop.i
	bright.i
	bbottom.i
	GadgetID.i
	
	*OnBeforeResize.AWPB_GUILO_OnBeforeResize_Proto
	*OnAfterResize.AWPB_GUILO_OnAfterResize_Proto
	
	List *childs.____AWPB_GUILO_Sizer_Data()
EndStructure
Structure ____AWPB_GUILO_Sizer
	*vt.____AWPB_GUILO_Sizer_VT
	
	sizers.____AWPB_GUILO_Sizer_Data
	
	parent.i
	parenttype.b
EndStructure

Procedure.i AWPB_CreateSizerObj(ParentID.i, ParentType.b = #AWPB_GUILO_SIZER_WINDOW)
	Protected *this.____AWPB_GUILO_Sizer
  
	Select ParentType
	  Case #AWPB_GUILO_SIZER_WINDOW
	    If Not IsWindow(ParentID) 
	      ProcedureReturn #Null
	    EndIf
	  Case #AWPB_GUILO_SIZER_CONTAINER
	    If Not IsGadget(ParentID)
	      ProcedureReturn #Null
	    EndIf
	EndSelect
	
	*this = AllocateMemory(SizeOf(____AWPB_GUILO_Sizer))
	If *this 
		InitializeStructure(*this, ____AWPB_GUILO_Sizer)
		*this\vt              = ?____AWPB_GUILO_Sizer_VT
		*this\parent          = ParentID
		*this\parenttype      = ParentType
		*this\sizers\l        = 0
		*this\sizers\t        = 0
		
		Select ParentType
		    Case #AWPB_GUILO_SIZER_WINDOW
		      *this\sizers\r        = WindowWidth(ParentID)
		      *this\sizers\b        = WindowHeight(ParentID)
		    Case #AWPB_GUILO_SIZER_CONTAINER
		      *this\sizers\r        = GadgetWidth(ParentID)
		      *this\sizers\b        = GadgetHeight(ParentID)
		EndSelect
		*this\sizers\w        			= *this\sizers\r
		*this\sizers\h        			= *this\sizers\b
		*this\sizers\bleft   			  = 0
		*this\sizers\btop    			  = 0
		*this\sizers\bright   			= 0
		*this\sizers\bbottom  			= 0
		*this\sizers\GadgetID 			= #PB_Any
		*this\sizers\type     			= #AWPB_GUILO_SIZER_VBOX
		*this\sizers\mode     			= #AWPB_GUILO_SIZER_REL
		*this\sizers\size     			= 100
		*this\sizers\OnBeforeResize = #Null
		*this\sizers\OnAfterResize  = #Null
		
		ProcedureReturn *this
	EndIf
	
	ProcedureReturn #Null
EndProcedure
Procedure   ____AWPB_GUILO_Sizer_DestroyChild(*sizer.____AWPB_GUILO_Sizer_Data)
	ForEach *sizer\childs()
		____AWPB_GUILO_Sizer_DestroyChild(*sizer\childs())
	Next
	FreeList(*sizer\childs())
	FreeMemory(*sizer)
EndProcedure
Procedure   ____AWPB_GUILO_Sizer_Destroy(*this.____AWPB_GUILO_Sizer)
	ForEach *this\sizers\childs()
		____AWPB_GUILO_Sizer_DestroyChild(*this\sizers\childs())
	Next
	FreeList(*this\sizers\childs())
	FreeMemory(*this)
EndProcedure
Procedure   ____AWPB_GUILO_Sizer_FinishChild(*sizer.____AWPB_GUILO_Sizer_Data, ExecuteBeforeResizeCallbacks.b, ExecuteAfterResizeCallbacks.b)
	Protected l.i, t.i, r.i, b.i, w.i, h.i, gl.i, gt.i, gb.i, gr.i, gw.i, gh.i, ol.i, ot.i, ow.i, oh.i
	
	l = *sizer\l
	t = *sizer\t
	r = *sizer\r
	b = *sizer\b
	w = *sizer\w
	h = *sizer\h
	
	If *sizer\type = #AWPB_GUILO_SIZER_GDG
		If IsGadget(*sizer\GadgetID)
		  ol = l
		  ot = t
		  ow = w
		  oh = h
			gl = *sizer\l + *sizer\bleft
			gt = *sizer\t + *sizer\btop
			gr = *sizer\r - *sizer\bright
			gb = *sizer\b - *sizer\bbottom
			If gl > gr : gl = *sizer\l : EndIf
			If gt > gb : gl = *sizer\t : EndIf
			If gr < gl : gr = *sizer\r : EndIf
			If gb < gt : gb = *sizer\b : EndIf
			gw = gr - gl
			gh = gb - gt 
	    If (l <> ol) Or (t <> ot) Or (gw <> ow) Or (gh <> oh)
	  		If ExecuteBeforeResizeCallbacks 
		  	  If *sizer\OnBeforeResize <> #Null
			      *sizer\OnBeforeResize(*sizer\GadgetID)
			    EndIf  
			  EndIf  
  			ResizeGadget(*sizer\GadgetID, gl, gt, gw, gh)
	  		If ExecuteAfterResizeCallbacks 
		  	  If *sizer\OnAfterResize <> #Null
			      *sizer\OnAfterResize(*sizer\GadgetID, gl, gt, gw, gh)
			    EndIf  
			  EndIf  
			EndIf
		EndIf
	Else
		ForEach *sizer\childs()
			With *sizer\childs()
				If *sizer\type = #AWPB_GUILO_SIZER_HBOX
					; horizontal - t, b and h static
					\t = t
					\b = b
					\h = h
					If \mode = #AWPB_GUILO_SIZER_FIX
						\l = l
						\w = \size
						\r = \l + \w - 1
						l  = \r + 1
					ElseIf \mode = #AWPB_GUILO_SIZER_REL
						\l = l
						\w = (w * \size) / 100
						\r = \l + \w - 1
						l  = \r + 1
					EndIf
				ElseIf *sizer\type = #AWPB_GUILO_SIZER_VBOX
					; vertical - l, r and w static
					\l = l
					\r = r
					\w = w
					If \mode = #AWPB_GUILO_SIZER_FIX
						\t = t
						\h = \size
						\b = \t + \h - 1
						t  = \b + 1
					ElseIf \mode = #AWPB_GUILO_SIZER_REL
						\t = t
						\h = (h * \size) / 100
						\b = \t + \h - 1
						t  = \b + 1
					EndIf
				EndIf
			EndWith
			____AWPB_GUILO_Sizer_FinishChild(*sizer\childs(), ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks)
		Next
	EndIf
EndProcedure
Procedure   ____AWPB_GUILO_Sizer_Finish(*this.____AWPB_GUILO_Sizer, ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
	____AWPB_GUILO_Sizer_FinishChild(@*this\sizers, ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks)
EndProcedure
Procedure   ____AWPB_GUILO_Sizer_Resize(*this.____AWPB_GUILO_Sizer, ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
  Select *this\parenttype
    Case #AWPB_GUILO_SIZER_WINDOW
      *this\sizers\r        = WindowWidth(*this\parent)
      *this\sizers\b        = WindowHeight(*this\parent)
    Case #AWPB_GUILO_SIZER_CONTAINER
      *this\sizers\r        = GadgetWidth(*this\parent)
      *this\sizers\b        = GadgetHeight(*this\parent)
	EndSelect
	*this\sizers\w = *this\sizers\r
	*this\sizers\h = *this\sizers\b
	____AWPB_GUILO_Sizer_Finish(*this, ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks)
EndProcedure
Procedure.b ____AWPB_GUILO_Sizer_AddGadget(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data, GadgetID.i, Mode.b, Size.i, BorderLeft.i = 0, BorderTop.i = 0, BorderRight.i = 0, BorderBottom.i = 0, *OnBeforeResizeCallback.AWPB_GUILO_OnBeforeResize_Proto = #Null, *OnAfterResizeCallback.AWPB_GUILO_OnAfterResize_Proto = #Null)
	Protected *sizer.____AWPB_GUILO_Sizer_Data
	
	If IsGadget(GadgetID) 
		*sizer = AllocateMemory(SizeOf(____AWPB_GUILO_Sizer_Data))
		If *sizer
			InitializeStructure(*sizer, ____AWPB_GUILO_Sizer_Data)
			With *sizer
				\type     			= #AWPB_GUILO_SIZER_GDG
				\mode     			= Mode
				\size     			= Size
				\bleft    			= BorderLeft
				\btop     			= BorderTop
				\bright   			= BorderRight
				\bbottom  			= BorderBottom
				\GadgetID 			= GadgetID
				\OnBeforeResize = *OnBeforeResizeCallback
				\OnAfterResize  = *OnAfterResizeCallback
			EndWith
			
			If *ParentSizer
				AddElement(*ParentSizer\childs())
				*ParentSizer\childs() = *sizer
			Else
				AddElement(*this\sizers\childs())
				*this\sizers\childs() = *sizer
			EndIf
			
			ProcedureReturn #True
		EndIf
	EndIf
	
	ProcedureReturn #False
EndProcedure
Procedure.i ____AWPB_GUILO_Sizer_AddSizer(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data, Type.b, Mode.b, Size.i)
	Protected *sizer.____AWPB_GUILO_Sizer_Data
	
	*sizer = AllocateMemory(SizeOf(____AWPB_GUILO_Sizer_Data))
	If *sizer
		InitializeStructure(*sizer, ____AWPB_GUILO_Sizer_Data)
		With *sizer
			\type     			= Type
			\mode     			= Mode
			\size     			= Size
			\bleft    			= 0
			\btop     			= 0
			\bright   			= 0
			\bbottom  			= 0
			\GadgetID 			= #PB_Any
			\OnBeforeResize = #Null
			\OnAfterResize  = #Null
		EndWith
		
		If *ParentSizer
			AddElement(*ParentSizer\childs())
			*ParentSizer\childs() = *sizer
		Else
			AddElement(*this\sizers\childs())
			*this\sizers\childs() = *sizer
		EndIf
	EndIf
	
	ProcedureReturn *sizer		
EndProcedure
Procedure.i ____AWPB_GUILO_Sizer_MinWidth(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data = #Null)
	;- TODO
	
EndProcedure
Procedure.i ____AWPB_GUILO_Sizer_MinHeight(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data = #Null)
	;- TODO
	
EndProcedure

DataSection ;{
____AWPB_GUILO_Sizer_VT:
  Data.i @____AWPB_GUILO_Sizer_Destroy()
  Data.i @____AWPB_GUILO_Sizer_Finish()
  Data.i @____AWPB_GUILO_Sizer_Resize()
  Data.i @____AWPB_GUILO_Sizer_AddGadget()
  Data.i @____AWPB_GUILO_Sizer_AddSizer()
  Data.i @____AWPB_GUILO_Sizer_MinWidth()
  Data.i @____AWPB_GUILO_Sizer_MinHeight()  
EndDataSection ;}


; IDE Options = PureBasic 4.61 Beta 1 (Linux - x64)
; CursorPosition = 211
; FirstLine = 195
; Folding = ---
; EnableXP